"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.proceedAPIAroundAdviceFactory = exports.flatProceedAPIAroundAdviceFactory = void 0;

var _functional = require("../../misc/functional");

/**
 * @type {Object}
 */
var proceedAPIAroundAdviceFactory = {
  proceedWithinProceed: _functional.noActionFunc,
  proceedOutOfProceed: function proceedOutOfProceed(_ref) {
    var trapExecutor = _ref.trapExecutor,
        trapArgs = _ref.trapArgs,
        rule = _ref.rule,
        returnValue = _ref.returnValue,
        proceedCallback = _ref.proceedCallback,
        next = _ref.next;
    returnValue = next(trapArgs);

    if (typeof proceedCallback === "function") {
      returnValue = trapExecutor.executeProceedCallback(trapArgs, rule, returnValue, proceedCallback);
    }

    return returnValue;
  }
};
/**
 * @type {Object}
 */

exports.proceedAPIAroundAdviceFactory = proceedAPIAroundAdviceFactory;
var flatProceedAPIAroundAdviceFactory = {
  proceedWithinProceed: function proceedWithinProceed(_ref2) {
    var trapExecutor = _ref2.trapExecutor,
        trapArgs = _ref2.trapArgs,
        next = _ref2.next,
        context = _ref2.context;
    var returnValue;
    var hasMutatedContext = false;

    try {
      returnValue = next(trapArgs);
      trapExecutor.mutateFlatProceedContext(trapArgs, context);
      hasMutatedContext = true;
    } catch (e) {
      !hasMutatedContext && trapExecutor.mutateFlatProceedContext(trapArgs, context);
      throw e;
    }

    return returnValue;
  },
  proceedOutOfProceed: function proceedOutOfProceed(_ref3) {
    var returnValue = _ref3.returnValue;
    return returnValue;
  }
};
exports.flatProceedAPIAroundAdviceFactory = flatProceedAPIAroundAdviceFactory;
//# sourceMappingURL=aroundAdviceFactory.js.map