"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = handlerFactory;

var _trapHandlerForRules = _interopRequireDefault(require("../trap/trapHandlerForRules"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * Factory function to generate a new handler object for the given proxy rules.
 * @param {Object|Array} proxyRules The proxy rules.
 * @return {Object} The handler object for the given proxy rules.
 */
function handlerFactory(proxyRules) {
  var handler = (0, _trapHandlerForRules["default"])(proxyRules);
  return handler;
}
//# sourceMappingURL=handlerFactory.js.map