"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Pointcut2 = _interopRequireDefault(require("./Pointcut"));

var _BeforeAdvice = _interopRequireDefault(require("../advices/BeforeAdvice"));

var _AfterAdvice = _interopRequireDefault(require("../advices/AfterAdvice"));

var _AroundAdvice = _interopRequireDefault(require("../advices/AroundAdvice"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var FunctionCallPointcut = /*#__PURE__*/function (_Pointcut) {
  _inherits(FunctionCallPointcut, _Pointcut);

  var _super = _createSuper(FunctionCallPointcut);

  function FunctionCallPointcut() {
    _classCallCheck(this, FunctionCallPointcut);

    return _super.apply(this, arguments);
  }

  _createClass(FunctionCallPointcut, [{
    key: "before",
    value:
    /**
     * Register a before advice for this pointcut.
     * @param {Function} adviceFunc The advice function. A function which receives the parameters
     * of the underlying proxied function before calling it.
     * @return {FunctionCallPointcut} A reference to this instance.
     */
    function before(adviceFunc) {
      this.advices.push(new _BeforeAdvice["default"](adviceFunc));
      return this;
    }
    /**
     * Register an after advice for this pointcut.
     * @param {Function} adviceFunc The advice function. A higher-order function which will receive
     * the parameters of the proxied function and MUST return a function
     * which will receive the return value of the underlying proxied function
     * as parameter.
     * @return {FunctionCallPointcut} A reference to this instance.
     */

  }, {
    key: "after",
    value: function after(adviceFunc) {
      this.advices.push(new _AfterAdvice["default"](adviceFunc));
      return this;
    }
    /**
     * Register an around advice for this pointcut.
     * @param {Function} adviceFunc The advice function. A higher-order function which will receive
     * the "proceed" function as parameter and which MUST return a function which will receive the
     * parameters of the underlying proxied function.
     * When options.flat = true, if the advice proceeds, the return value to return to the caller
     * will be returned by the "proceed" function. The advice function may return another return
     * value instead of the one returned. Otherwise (if false), if the advice function proceeds,
     * the callback given to "proceed" will receive the return value to return to the caller
     * or may return another value instead of the current return value.
     * @param {Object} [options] An optional object with options.
     * @param {boolean} [options.flat=false] True to use the Flat Proceed API. Defaults to false.
     * @return {FunctionCallPointcut} A reference to this instance.
     */

  }, {
    key: "around",
    value: function around(adviceFunc) {
      var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          _ref$flat = _ref.flat,
          flat = _ref$flat === void 0 ? false : _ref$flat;

      this.advices.push(new _AroundAdvice["default"](adviceFunc, {
        flat: flat
      }));
      return this;
    }
    /**
     * Shorthand for "around(adviceFn, { flat: true })".
     * @param {Function} adviceFunc The advice function as in the "around" method.
     * @return {FunctionCallPointcut} A reference to this instance.
     */

  }, {
    key: "flatAround",
    value: function flatAround(adviceFunc) {
      return this.around(adviceFunc, {
        flat: true
      });
    }
  }]);

  return FunctionCallPointcut;
}(_Pointcut2["default"]);

exports["default"] = FunctionCallPointcut;
//# sourceMappingURL=FunctionCallPointcut.js.map