"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.apply = apply;
exports.call = call;
exports.construct = construct;
exports.get = get;
exports.set = set;

var _FunctionCallPointcut = _interopRequireDefault(require("./FunctionCallPointcut"));

var _MethodCallPointcut = _interopRequireDefault(require("./MethodCallPointcut"));

var _ObjectConstructionPointcut = _interopRequireDefault(require("./ObjectConstructionPointcut"));

var _PropertyGettingPointcut = _interopRequireDefault(require("./PropertyGettingPointcut"));

var _PropertySettingPointcut = _interopRequireDefault(require("./PropertySettingPointcut"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * Returns a new function call pointcut.
 * @return {FunctionCallPointcut} A function call pointcut.
 */
function apply() {
  return new _FunctionCallPointcut["default"]();
}
/**
 * Returns a new method call pointcut.
 * @return {MethodCallPointcut} A method call pointcut.
 */


function call() {
  return new _MethodCallPointcut["default"]();
}
/**
 * Returns a new object construction pointcut.
 * @return {ObjectConstructionPointcut} An object construction pointcut.
 */


function construct() {
  return new _ObjectConstructionPointcut["default"]();
}
/**
 * Returns a new property getting pointcut.
 * @return {PropertyGettingPointcut} A property getting pointcut.
 */


function get() {
  return new _PropertyGettingPointcut["default"]();
}
/**
 * Returns a new property setting pointcut.
 * @return {PropertySettingPointcut} A property setting pointcut.
 */


function set() {
  return new _PropertySettingPointcut["default"]();
}
//# sourceMappingURL=pointcuts.js.map