"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _declarativeFactory = _interopRequireDefault(require("../../object-handling/declarative-factory"));

var _MethodCallPointcut = _interopRequireDefault(require("../pointcuts/MethodCallPointcut"));

var _PropertyGettingPointcut = _interopRequireDefault(require("../pointcuts/PropertyGettingPointcut"));

var _PropertySettingPointcut = _interopRequireDefault(require("../pointcuts/PropertySettingPointcut"));

var _FunctionCallPointcut = _interopRequireDefault(require("../pointcuts/FunctionCallPointcut"));

var _ObjectConstructionPointcut = _interopRequireDefault(require("../pointcuts/ObjectConstructionPointcut"));

var _ExactRule = _interopRequireDefault(require("../rules/ExactRule"));

var _applyRule = _interopRequireDefault(require("../rules/applyRule"));

var _constructRule = _interopRequireDefault(require("../rules/constructRule"));

var _pointcuts = require("../pointcuts/pointcuts");

var _BeforeAdvice = _interopRequireDefault(require("../advices/BeforeAdvice"));

var _AroundAdvice = _interopRequireDefault(require("../advices/AroundAdvice"));

var _CallTrapExecutor = _interopRequireDefault(require("./executors/CallTrapExecutor"));

var _GetTrapExecutor = _interopRequireDefault(require("./executors/GetTrapExecutor"));

var _SetTrapExecutor = _interopRequireDefault(require("./executors/SetTrapExecutor"));

var _ApplyTrapExecutor = _interopRequireDefault(require("./executors/ApplyTrapExecutor"));

var _ConstructTrapExecutor = _interopRequireDefault(require("./executors/ConstructTrapExecutor"));

var _introspection = require("../../object-handling/introspection");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Trap = /*#__PURE__*/function () {
  function Trap() {
    _classCallCheck(this, Trap);

    _defineProperty(this, "advices", {
      // Requires matching (get trap). Requires distribution.
      call: [],
      // Requires matching (get trap). Requires distribution.
      get: [],
      // Requires matching (set trap). Requires distribution.
      set: [],
      // Does not require matching (apply trap). Requires distribution.
      apply: [],
      // Does not require matching (construct trap). Requires distribution.
      construct: []
    });

    _defineProperty(this, "distributedAdvices", {
      call: {
        before: void 0,
        around: void 0,
        after: void 0
      },
      get: {
        before: void 0,
        around: void 0,
        after: void 0
      },
      set: {
        before: void 0,
        around: void 0,
        after: void 0
      },
      apply: {
        before: void 0,
        around: void 0,
        after: void 0
      },
      construct: {
        before: void 0,
        around: void 0,
        after: void 0
      }
    });

    _defineProperty(this, "matchedDistributedAdvices", {
      call: new Map(),
      get: new Map(),
      set: new Map()
    });

    _defineProperty(this, "trapExecutors", {
      call: new _CallTrapExecutor["default"](),
      get: new _GetTrapExecutor["default"](),
      set: new _SetTrapExecutor["default"](),
      apply: new _ApplyTrapExecutor["default"](),
      construct: new _ConstructTrapExecutor["default"]()
    });
  }

  _createClass(Trap, [{
    key: "hasAtLeastOneAdviceOfPointcutType",
    value:
    /**
     * @private
     */
    function hasAtLeastOneAdviceOfPointcutType(pointcutType) {
      return !!this.advices[pointcutType].length;
    }
    /**
     * @private
     */

  }, {
    key: "addAdvices",
    value: function addAdvices(pointcutType, rule) {
      var _this = this;

      var advices = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
      advices.map(function (advice) {
        return _this.advices[pointcutType].push({
          rule: rule,
          advice: advice
        });
      });
    }
    /**
     * @private
     */

  }, {
    key: "lazilyDistributeAdvices",
    value: function lazilyDistributeAdvices(pointcutType) {
      var _this2 = this;

      if ((0, _introspection.isUndefined)(this.distributedAdvices[pointcutType].before)) {
        this.distributedAdvices[pointcutType].before = [];
        this.distributedAdvices[pointcutType].around = [];
        this.distributedAdvices[pointcutType].after = [];

        var _iterator = _createForOfIteratorHelper(this.advices[pointcutType]),
            _step;

        try {
          var _loop = function _loop() {
            var _step$value = _step.value,
                rule = _step$value.rule,
                advice = _step$value.advice;
            var subKey = (0, _declarativeFactory["default"])([[function () {
              return advice instanceof _BeforeAdvice["default"];
            }, "before"], [function () {
              return advice instanceof _AroundAdvice["default"];
            }, "around"], "after"]);

            _this2.distributedAdvices[pointcutType][subKey].push({
              rule: rule,
              advice: advice
            });
          };

          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            _loop();
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      }
    }
    /**
     * For "call", "get" and "set" advices.
     *
     * @private
     */

  }, {
    key: "lazilyMatchAdvices",
    value: function lazilyMatchAdvices(pointcutType, property) {
      this.lazilyDistributeAdvices(pointcutType);
      var map = this.matchedDistributedAdvices[pointcutType];

      if (!map.has(property)) {
        var node = {
          before: [],
          around: [],
          after: []
        };
        map.set(property, node);
        var beforeAdvices = this.distributedAdvices[pointcutType].before;
        var aroundAdvices = this.distributedAdvices[pointcutType].around;
        var afterAdvices = this.distributedAdvices[pointcutType].after;

        var match = function match(advices) {
          return function (key) {
            var _iterator2 = _createForOfIteratorHelper(advices),
                _step2;

            try {
              for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                var _step2$value = _step2.value,
                    rule = _step2$value.rule,
                    advice = _step2$value.advice;
                var matches = rule.matches(property);
                if (matches) node[key].push({
                  rule: rule,
                  advice: advice
                });
              }
            } catch (err) {
              _iterator2.e(err);
            } finally {
              _iterator2.f();
            }
          };
        };

        match(beforeAdvices)("before");
        match(aroundAdvices)("around");
        match(afterAdvices)("after");
      }
    }
    /**
     * Adds a pointcut and its associated rule to this trap.
     * If a pointcut is of an unknown type, it will be ignored.
     *
     * @param {Pointcut|Function} pointcut The pointcut or a function (for implicit apply and construct pointcuts).
     * @param {Rule} rule The rule.
     * @return {Trap} This trap object.
     */

  }, {
    key: "addPointcutRule",
    value: function addPointcutRule(pointcut, rule) {
      var isImplicitBeforeAdvice = function isImplicitBeforeAdvice() {
        return typeof pointcut === "function" && rule instanceof _ExactRule["default"];
      };

      var pointcutType = (0, _declarativeFactory["default"])([[function () {
        return pointcut instanceof _MethodCallPointcut["default"];
      }, "call"], [function () {
        return pointcut instanceof _PropertyGettingPointcut["default"];
      }, "get"], [function () {
        return pointcut instanceof _PropertySettingPointcut["default"];
      }, "set"], [function () {
        var isImplicit = isImplicitBeforeAdvice() && rule.property === _applyRule["default"];

        if (isImplicit || pointcut instanceof _FunctionCallPointcut["default"]) {
          if (isImplicit) pointcut = (0, _pointcuts.apply)().before(pointcut);
          return true;
        }

        return false;
      }, "apply"], [function () {
        var isImplicit = isImplicitBeforeAdvice() && rule.property === _constructRule["default"];

        if (isImplicit || pointcut instanceof _ObjectConstructionPointcut["default"]) {
          if (isImplicit) pointcut = (0, _pointcuts.construct)().before(pointcut);
          return true;
        }

        return false;
      }, "construct"]]);

      if (pointcutType) {
        var _pointcut = pointcut,
            advices = _pointcut.advices;
        this.addAdvices(pointcutType, rule, advices);
      }

      return this;
    }
  }, {
    key: "hasGets",
    value: function hasGets() {
      return this.hasAtLeastOneAdviceOfPointcutType("call") || this.hasAtLeastOneAdviceOfPointcutType("get");
    }
  }, {
    key: "hasSets",
    value: function hasSets() {
      return this.hasAtLeastOneAdviceOfPointcutType("set");
    }
  }, {
    key: "hasApplies",
    value: function hasApplies() {
      return this.hasAtLeastOneAdviceOfPointcutType("apply");
    }
  }, {
    key: "hasConstructs",
    value: function hasConstructs() {
      return this.hasAtLeastOneAdviceOfPointcutType("construct");
    }
  }, {
    key: "get",
    value: function get(target, property, receiver) {
      // Method call and property access (getting) advices.
      this.lazilyMatchAdvices("get", property);
      this.lazilyMatchAdvices("call", property);

      var _this$matchedDistribu = this.matchedDistributedAdvices.get.get(property),
          getBefore = _this$matchedDistribu.before,
          getAround = _this$matchedDistribu.around,
          getAfter = _this$matchedDistribu.after;

      var propertyValue = this.trapExecutors.get.execute([target, property, receiver], getBefore, getAround, getAfter);

      var _this$matchedDistribu2 = this.matchedDistributedAdvices.call.get(property),
          callBefore = _this$matchedDistribu2.before,
          callAround = _this$matchedDistribu2.around,
          callAfter = _this$matchedDistribu2.after;

      var returnValue = this.trapExecutors.call.execute([target, property, receiver, propertyValue], callBefore, callAround, callAfter);
      return returnValue;
    }
  }, {
    key: "set",
    value: function set(target, property, value, receiver) {
      // Property access (setting) advices.
      this.lazilyMatchAdvices("set", property);

      var _this$matchedDistribu3 = this.matchedDistributedAdvices.set.get(property),
          before = _this$matchedDistribu3.before,
          around = _this$matchedDistribu3.around,
          after = _this$matchedDistribu3.after;

      return this.trapExecutors.set.execute([target, property, value, receiver], before, around, after);
    }
  }, {
    key: "apply",
    value: function apply(target, thisArg, argumentsList) {
      // Function call advices.
      this.lazilyDistributeAdvices("apply");
      var _this$distributedAdvi = this.distributedAdvices.apply,
          before = _this$distributedAdvi.before,
          around = _this$distributedAdvi.around,
          after = _this$distributedAdvi.after;
      return this.trapExecutors.apply.execute([target, thisArg, argumentsList], before, around, after);
    }
  }, {
    key: "construct",
    value: function construct(target, argumentsList, newTarget) {
      // Object construction via the "new" keyword advices.
      this.lazilyDistributeAdvices("construct");
      var _this$distributedAdvi2 = this.distributedAdvices.construct,
          before = _this$distributedAdvi2.before,
          around = _this$distributedAdvi2.around,
          after = _this$distributedAdvi2.after;
      return this.trapExecutors.construct.execute([target, argumentsList, newTarget], before, around, after);
    }
  }]);

  return Trap;
}();

exports["default"] = Trap;
//# sourceMappingURL=Trap.js.map