"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _functional = require("../../../misc/functional");

var _introspection = require("../../../object-handling/introspection");

var _declarativeFactory = _interopRequireDefault(require("../../../object-handling/declarative-factory"));

var _isAOPProxy = require("../../isAOPProxy");

var _aroundAdviceFactory = require("./factory/aroundAdviceFactory");

var _NotImplementedError = _interopRequireDefault(require("../../../errors/NotImplementedError"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TrapExecutor = /*#__PURE__*/function () {
  function TrapExecutor() {
    _classCallCheck(this, TrapExecutor);

    _defineProperty(this, "nameOf", this.constructor.name);

    _defineProperty(this, "execContextStack", []);

    _defineProperty(this, "execContextID", -1);
  }

  _createClass(TrapExecutor, [{
    key: "execute",
    value: function execute(trapArgs, before, around, after) {
      var _this = this;

      var returnValue = this.withinExecContext(function () {
        _this.newExecutionContext();

        _this.startExecutionContext(trapArgs);

        _this.beforePhase(trapArgs, before);

        var returnValue = _this.aroundProceedPhase(trapArgs, around);

        _this.afterPhase(trapArgs, after, returnValue);

        _this.endExecutionContext(trapArgs);

        _this.cleanUpExecutionContext();

        return returnValue;
      });
      return returnValue;
    }
    /**
     * @private
     */

  }, {
    key: "withinExecContext",
    value: function withinExecContext(callback) {
      var isNewContext = false;

      if (!TrapExecutor.isWithinExecContext) {
        isNewContext = true;
        TrapExecutor.isWithinExecContext = true;
        TrapExecutor.newTransversalExecutionContext();
      }

      var returnValue = callback();
      if (isNewContext) TrapExecutor.cleanUpTransversalExecutionContext();
      return returnValue;
    }
  }, {
    key: "notWithinExecContext",
    value: function notWithinExecContext(callback) {
      var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          _ref$target = _ref.target,
          target = _ref$target === void 0 ? void 0 : _ref$target,
          _ref$isPerformingUnde = _ref.isPerformingUnderlyingOperation,
          isPerformingUnderlyingOperation = _ref$isPerformingUnde === void 0 ? false : _ref$isPerformingUnde,
          proceed = _ref.proceed;

      var current = TrapExecutor.isWithinExecContext;
      var isTargetAOPProxy = target && target[_isAOPProxy.isAOPProxy];

      if (isPerformingUnderlyingOperation && target && !isTargetAOPProxy) {
        TrapExecutor.ExecContextStack[TrapExecutor.ExecContextID].hasEffectivelyPerformedUnderlyingOperation = true;
      }

      if (!isTargetAOPProxy) {
        TrapExecutor.isWithinExecContext = false;
      }

      var wrappedProceed = function wrappedProceed() {
        var snapshot = TrapExecutor.isWithinExecContext;
        TrapExecutor.isWithinExecContext = current;
        var returnValue = proceed.apply(void 0, arguments);
        TrapExecutor.isWithinExecContext = snapshot;
        return returnValue;
      };

      var returnValue = callback({
        proceed: wrappedProceed
      });
      TrapExecutor.isWithinExecContext = current;
      return returnValue;
    }
    /**
     * @private
     */

  }, {
    key: "newExecutionContext",
    value: function newExecutionContext() {
      var context = {
        finalParams: void 0,
        hasPerformedUnderlyingOperation: false
      };
      this.execContextStack.push(context);
      this.execContextID++;
    }
  }, {
    key: "startExecutionContext",
    value: function startExecutionContext(trapArgs) {}
  }, {
    key: "endExecutionContext",
    value: function endExecutionContext(trapArgs) {}
    /**
     * @private
     */

  }, {
    key: "cleanUpExecutionContext",
    value: function cleanUpExecutionContext() {
      this.execContextStack.pop();
      this.execContextID--;
    }
    /**
     * @private
     */

  }, {
    key: "unsupportedMultipleProceeds",
    value: function unsupportedMultipleProceeds(advice, rule) {
      throw new Error("Multiple proceeds for the same around advice are not supported,\n    subsequent proceed has been ignored. advice: ".concat(advice, ", rule: ").concat(rule));
    }
  }, {
    key: "executeBeforeAdvice",
    value: function executeBeforeAdvice(trapArgs, advice, rule) {
      throw new _NotImplementedError["default"](this.nameOf, "executeBeforeAdvice");
    }
  }, {
    key: "executeAroundAdvice",
    value: function executeAroundAdvice(trapArgs, advice, rule, proceed, context) {
      throw new _NotImplementedError["default"](this.nameOf, "executeAroundAdvice");
    }
  }, {
    key: "executeAfterAdvice",
    value: function executeAfterAdvice(trapArgs, advice, rule, returnValue) {
      throw new _NotImplementedError["default"](this.nameOf, "executeAfterAdvice");
    }
  }, {
    key: "performUnderlyingOperation",
    value: function performUnderlyingOperation(trapArgs) {
      throw new _NotImplementedError["default"](this.nameOf, "performUnderlyingOperation");
    }
  }, {
    key: "executeProceedCallback",
    value: function executeProceedCallback(trapArgs, rule, returnValue, callback) {
      throw new _NotImplementedError["default"](this.nameOf, "executeProceedCallback");
    }
    /**
     * @private
     */

  }, {
    key: "beforePhase",
    value: function beforePhase(trapArgs, before) {
      var _iterator = _createForOfIteratorHelper(before),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _step$value = _step.value,
              rule = _step$value.rule,
              advice = _step$value.advice;
          this.executeBefore(trapArgs, advice, rule);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
    /**
     * @private
     */

  }, {
    key: "executeBefore",
    value: function executeBefore(trapArgs, advice, rule) {
      this.executeBeforeAdvice(trapArgs, advice, rule);
    }
    /**
     * @private
     */

  }, {
    key: "afterPhase",
    value: function afterPhase(trapArgs, after, returnValue) {
      var _iterator2 = _createForOfIteratorHelper(after),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _step2$value = _step2.value,
              rule = _step2$value.rule,
              advice = _step2$value.advice;
          this.executeAfter(trapArgs, advice, rule, returnValue);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    }
    /**
     * @private
     */

  }, {
    key: "executeAfter",
    value: function executeAfter(trapArgs, advice, rule, returnValue) {
      this.executeAfterAdvice(trapArgs, advice, rule, returnValue);
    }
    /**
     * @private
     */

  }, {
    key: "aroundProceedPhase",
    value: function aroundProceedPhase(trapArgs, around) {
      var _this2 = this;

      var aroundAdvicesMiddlewares = around.map(function (_ref2) {
        var advice = _ref2.advice,
            rule = _ref2.rule;
        return function (_ref3, next) {
          var _ref4 = _slicedToArray(_ref3, 1),
              trapArgs = _ref4[0];

          var aroundAdviceFactory = (0, _declarativeFactory["default"])([[advice.flat, _aroundAdviceFactory.flatProceedAPIAroundAdviceFactory], _aroundAdviceFactory.proceedAPIAroundAdviceFactory]);
          var proceedCallback = void 0;
          var proceedReturnValue = void 0;
          var hasProceeded = false;
          var context = {};

          var proceed = function proceed() {
            var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : void 0;
            var func = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : void 0;

            if (hasProceeded) {
              _this2.unsupportedMultipleProceeds(advice, rule);

              return proceedReturnValue;
            }

            hasProceeded = true;
            var finalParams = void 0;
            var finalFunc = void 0;

            if ((0, _introspection.isArray)(params)) {
              finalParams = params;
              finalFunc = typeof func === "function" ? func : void 0;
            } else if (typeof params === "function") finalFunc = params;

            proceedCallback = finalFunc;
            _this2.execContextStack[_this2.execContextID].finalParams = finalParams || _this2.execContextStack[_this2.execContextID].finalParams;
            TrapExecutor.ExecContextStack[TrapExecutor.ExecContextID].finalParams = _this2.execContextStack[_this2.execContextID].finalParams;

            _this2.onProceed(_this2.execContextStack[_this2.execContextID].finalParams);

            proceedReturnValue = aroundAdviceFactory.proceedWithinProceed({
              trapExecutor: _this2,
              trapArgs: trapArgs,
              next: next,
              context: context
            });
            return proceedReturnValue;
          };

          var returnValue = _this2.executeAroundAdvice(trapArgs, advice, rule, proceed, context);

          return hasProceeded ? aroundAdviceFactory.proceedOutOfProceed({
            trapExecutor: _this2,
            trapArgs: trapArgs,
            rule: rule,
            returnValue: returnValue,
            proceedCallback: proceedCallback,
            next: next
          }) : _this2.onNoProceed(returnValue);
        };
      });
      aroundAdvicesMiddlewares.push(function (_ref5) {
        var _ref6 = _slicedToArray(_ref5, 1),
            trapArgs = _ref6[0];

        _this2.execContextStack[_this2.execContextID].hasPerformedUnderlyingOperation = true;
        return _this2.performUnderlyingOperation(trapArgs);
      });
      var aroundProceedChain = (0, _functional.chain)(aroundAdvicesMiddlewares);
      var returnValue = aroundProceedChain(trapArgs);
      return this["return"](trapArgs, returnValue);
    }
  }, {
    key: "return",
    value: function _return(trapArgs, returnValue) {
      return returnValue;
    }
  }, {
    key: "mutateFlatProceedContext",
    value: function mutateFlatProceedContext(trapArgs, context) {}
  }, {
    key: "onProceed",
    value: function onProceed(finalParams) {}
  }, {
    key: "onNoProceed",
    value: function onNoProceed(returnValue) {}
  }], [{
    key: "newTransversalExecutionContext",
    value:
    /**
     * @static
     * @private
     */
    function newTransversalExecutionContext() {
      var context = {
        finalParams: void 0,
        hasEffectivelyPerformedUnderlyingOperation: false
      };
      TrapExecutor.ExecContextStack.push(context);
      TrapExecutor.ExecContextID++;
      TrapExecutor.ExecContextMap[TrapExecutor.ExecContextID] = true;
    }
    /**
     * @static
     * @private
     */

  }, {
    key: "cleanUpTransversalExecutionContext",
    value: function cleanUpTransversalExecutionContext() {
      TrapExecutor.ExecContextStack.pop();
      var currId = TrapExecutor.ExecContextID;
      TrapExecutor.ExecContextID--;

      if (TrapExecutor.ExecContextMap[currId]) {
        delete TrapExecutor.ExecContextMap[currId];
        TrapExecutor.isWithinExecContext = false;
      }
    }
  }, {
    key: "getTransversalExecContextStackData",
    value: function getTransversalExecContextStackData(key) {
      var defaultValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : void 0;
      return TrapExecutor.ExecContextStack[TrapExecutor.ExecContextID] ? TrapExecutor.ExecContextStack[TrapExecutor.ExecContextID][key] : defaultValue;
    }
  }]);

  return TrapExecutor;
}();

exports["default"] = TrapExecutor;

_defineProperty(TrapExecutor, "isWithinExecContext", false);

_defineProperty(TrapExecutor, "ExecContextStack", []);

_defineProperty(TrapExecutor, "ExecContextID", -1);

_defineProperty(TrapExecutor, "ExecContextMap", {});
//# sourceMappingURL=TrapExecutor.js.map