"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withFunctionTrapExecutor = void 0;

var _clone = require("../../../object-handling/clone");

var _introspection = require("../../../object-handling/introspection");

var _throwErrorIfDoesNotImplement = require("./throwErrorIfDoesNotImplement");

var _NotImplementedError = _interopRequireDefault(require("../../../errors/NotImplementedError"));

var _TrapExecutor = _interopRequireDefault(require("../TrapExecutor"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get.bind(); } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var withFunctionTrapExecutor = function withFunctionTrapExecutor(superclass) {
  var NewClass = /*#__PURE__*/function (_superclass) {
    _inherits(NewClass, _superclass);

    var _super = _createSuper(NewClass);

    function NewClass() {
      var _this;

      _classCallCheck(this, NewClass);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _super.call.apply(_super, [this].concat(args));

      _defineProperty(_assertThisInitialized(_this), "executedAtLeastOnce", false);

      _defineProperty(_assertThisInitialized(_this), "finalTrapArgsMap", {});

      return _this;
    }

    _createClass(NewClass, [{
      key: "startExecutionContext",
      value: function startExecutionContext(trapArgs) {
        !this.executedAtLeastOnce && (0, _throwErrorIfDoesNotImplement.throwErrorIfDoesNotImplement)(superclass.prototype, "startExecutionContext", superclass);

        _get(_getPrototypeOf(NewClass.prototype), "startExecutionContext", this).call(this, trapArgs);

        if (!this.executedAtLeastOnce && !Object.prototype.hasOwnProperty.call(this, "execContextID")) throw new _NotImplementedError["default"](superclass.name, "execContextID");
      }
    }, {
      key: "endExecutionContext",
      value: function endExecutionContext(trapArgs) {
        !this.executedAtLeastOnce && (0, _throwErrorIfDoesNotImplement.throwErrorIfDoesNotImplement)(superclass.prototype, "endExecutionContext", superclass);

        _get(_getPrototypeOf(NewClass.prototype), "endExecutionContext", this).call(this, trapArgs);

        this.executedAtLeastOnce = true;
      }
    }, {
      key: "getFinalTrapArgs",
      value: function getFinalTrapArgs(trapArgs) {
        !this.executedAtLeastOnce && (0, _throwErrorIfDoesNotImplement.throwErrorIfDoesNotImplement)(this, "getTrapArgsArgumentsListIndex", superclass);
        var argumentsListIndex = this.getTrapArgsArgumentsListIndex();
        if (!this.executedAtLeastOnce && !Object.prototype.hasOwnProperty.call(this, "execContextStack")) throw new _NotImplementedError["default"](superclass.name, "execContextStack");
        var params = this.execContextStack[this.execContextID].finalParams;

        if ((0, _introspection.isArray)(params)) {
          trapArgs = _toConsumableArray(trapArgs);
          trapArgs[argumentsListIndex] = params;
        }

        return trapArgs;
      }
    }, {
      key: "executeAroundAdvice",
      value: function executeAroundAdvice(trapArgs, advice, rule, proceed, context) {
        trapArgs = this.getFinalTrapArgs(trapArgs);
        !this.executedAtLeastOnce && (0, _throwErrorIfDoesNotImplement.throwErrorIfDoesNotImplement)(superclass.prototype, "executeAroundAdvice", superclass);
        return _get(_getPrototypeOf(NewClass.prototype), "executeAroundAdvice", this).call(this, trapArgs, advice, rule, proceed, context);
      }
    }, {
      key: "executeAfterAdvice",
      value: function executeAfterAdvice(trapArgs, advice, rule, returnValue) {
        trapArgs = this.getFinalTrapArgs(trapArgs);
        !this.executedAtLeastOnce && (0, _throwErrorIfDoesNotImplement.throwErrorIfDoesNotImplement)(superclass.prototype, "executeAfterAdvice", superclass);

        _get(_getPrototypeOf(NewClass.prototype), "executeAfterAdvice", this).call(this, trapArgs, advice, rule, returnValue);
      }
    }, {
      key: "performUnderlyingOperation",
      value: function performUnderlyingOperation(trapArgs) {
        trapArgs = this.getFinalTrapArgs(trapArgs);
        !this.executedAtLeastOnce && (0, _throwErrorIfDoesNotImplement.throwErrorIfDoesNotImplement)(superclass.prototype, "performUnderlyingOperation", superclass);
        return _get(_getPrototypeOf(NewClass.prototype), "performUnderlyingOperation", this).call(this, trapArgs);
      }
    }, {
      key: "executeProceedCallback",
      value: function executeProceedCallback(trapArgs, rule, returnValue, callback) {
        trapArgs = this.getFinalTrapArgs(trapArgs);
        !this.executedAtLeastOnce && (0, _throwErrorIfDoesNotImplement.throwErrorIfDoesNotImplement)(superclass.prototype, "executeProceedCallback", superclass);
        return _get(_getPrototypeOf(NewClass.prototype), "executeProceedCallback", this).call(this, trapArgs, rule, returnValue, callback);
      }
    }, {
      key: "mutateFlatProceedContext",
      value: function mutateFlatProceedContext(trapArgs, context) {
        trapArgs = this.getFinalTrapArgs(trapArgs);
        var trapArgsArgumentsListIndex = this.getTrapArgsArgumentsListIndex();
        var argumentsList = trapArgs[trapArgsArgumentsListIndex];
        (0, _clone.shallowExtend)(context, {
          argumentsList: argumentsList,
          effectiveArgumentsList: _TrapExecutor["default"].getTransversalExecContextStackData("finalParams", argumentsList) || [],
          hasPerformedUnderlyingOperation: this.execContextStack[this.execContextID].hasPerformedUnderlyingOperation,
          hasEffectivelyPerformedUnderlyingOperation: _TrapExecutor["default"].getTransversalExecContextStackData("hasEffectivelyPerformedUnderlyingOperation")
        });
      }
    }]);

    return NewClass;
  }(superclass);

  Object.defineProperty(NewClass, "name", {
    value: "WithFunctionTrapExecutor(".concat(superclass.name, ")"),
    configurable: true
  });
  return NewClass;
};

exports.withFunctionTrapExecutor = withFunctionTrapExecutor;
//# sourceMappingURL=withFunctionTrapExecutor.js.map