"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LinkedQueue = void 0;

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Node = /*#__PURE__*/_createClass(function Node(data) {
  _classCallCheck(this, Node);

  this.data = data;
  this.next = null;
});

var LinkedQueue = /*#__PURE__*/function () {
  function LinkedQueue() {
    _classCallCheck(this, LinkedQueue);

    this.head = null;
    this.tail = null;
    this.length = 0;
  }
  /**
   * Push a value on the end.
   * @param {*} data the data to push.
   */


  _createClass(LinkedQueue, [{
    key: "enqueue",
    value: function enqueue(data) {
      var tmp = new Node(data);
      tmp.data = data;
      tmp.next = null;
      this.length++;

      if (this.head == null) {
        this.tail = this.head = tmp;
        return;
      }

      this.tail.next = tmp;
      this.tail = this.tail.next;
    }
    /**
     * Push an array of values on the end.
     * @param {*} data the array to push.
     */

  }, {
    key: "enqueueAll",
    value: function enqueueAll(list) {
      for (var i = 0; i < list.length; i++) {
        this.enqueue(list[i]);
      }
    }
    /**
     * Remove a value off the beginning.
     * @returns The removed value.
     */

  }, {
    key: "dequeue",
    value: function dequeue() {
      if (this.head == null) return null;
      this.length--;
      var data = this.head.data;
      var tmp = this.head;
      this.head = this.head.next;
      if (this.head == null) this.tail = null;
      tmp.next = null;
      return data;
    }
    /**
     * Remove all values off the beginning.
     * @param {Function} fn Each dequeued value will be called by fn(data) after dequeueing.
     */

  }, {
    key: "dequeueAll",
    value: function dequeueAll(fn) {
      while (this.head != null) {
        fn(this.dequeue());
      }
    }
    /**
     * Read the value at the beginning without removing it.
     */

  }, {
    key: "first",
    value: function first() {
      return this.head != null ? this.head.data : null;
    }
    /**
     * Read the value at the end without removing it.
     */

  }, {
    key: "last",
    value: function last() {
      return this.tail != null ? this.tail.data : null;
    }
    /**
     * @returns False if this contains no items.
     */

  }, {
    key: "isEmpty",
    value: function isEmpty() {
      return this.length === 0;
    }
    /**
     * @returns Removes all entries.
     */

  }, {
    key: "clear",
    value: function clear() {
      if (this.head == null) return;
      var tmp = null;

      while (this.head != null) {
        tmp = this.head;
        this.head = this.head.next;
        tmp.next = null;
        this.length--;
      }

      this.tail = null;
    }
  }, {
    key: "forEach",
    value: function forEach(fn) {
      var tmp = this.head;

      while (tmp != null) {
        fn(tmp.data);
        tmp = tmp.next;
      }
    }
  }]);

  return LinkedQueue;
}();

exports.LinkedQueue = LinkedQueue;
//# sourceMappingURL=LinkedQueue.js.map