"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NonCanonicalUUID = void 0;
exports.uniqueId = uniqueId;
exports.uuid = uuid;

var _global = require("./global");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

/**
 * Generates a new UUID.
 * @return {string} The UUID.
 */
function uuid() {
  var uuid = "";

  for (var i = 0; i < 32; i++) {
    var random = Math.random() * 16 | 0;

    if (i === 8 || i === 12 || i === 16 || i === 20) {
      uuid += "-";
    }

    uuid += (i === 12 ? 4 : i === 16 ? random & 3 | 8 : random).toString(16);
  }

  return uuid;
}
/**
 * Generates non-canonical UUIDs. Non-canonical UUIDs are standard
 * UUIDs with the current count suffixed. Wrapped in a class so that
 * separate instances can be created.
 */


var _count = /*#__PURE__*/new WeakMap();

var NonCanonicalUUID = /*#__PURE__*/function () {
  function NonCanonicalUUID() {
    _classCallCheck(this, NonCanonicalUUID);

    _classPrivateFieldInitSpec(this, _count, {
      writable: true,
      value: 0
    });
  }

  _createClass(NonCanonicalUUID, [{
    key: "generate",
    value:
    /** Generate a non-canonical UUID. */
    function generate() {
      var _this$count, _this$count2;

      _classPrivateFieldSet(this, _count, (_this$count = _classPrivateFieldGet(this, _count), _this$count2 = _this$count++, _this$count)), _this$count2;
      var UUID = uuid();
      return UUID + "-" + _classPrivateFieldGet(this, _count);
    }
  }]);

  return NonCanonicalUUID;
}();

exports.NonCanonicalUUID = NonCanonicalUUID;
var idCounter = "RANDOM_PREFIX";
/**
 * Generates a unique ID which can be used as an "id" attribute.
 * @param {string} [uniqueIdPrefix] Local unique ID prefix
 * @return {string} The unique ID.
 */

function uniqueId() {
  var uniqueIdPrefix = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "RANDOM_PREFIX";
  var globalObject = (0, _global.getGlobalObject)();
  globalObject[idCounter] = globalObject[idCounter] || 0;
  globalObject[idCounter]++;
  var uniqueIdCounter = globalObject[idCounter];
  var uniqueId = uniqueIdPrefix + uniqueIdCounter;
  return uniqueId;
}
//# sourceMappingURL=uuid.js.map